// This file is generated by kconfig_compiler from kding.kcfg.
// All changes you do to this file will be lost.
#ifndef SETTINGS_H
#define SETTINGS_H

#include <kconfigskeleton.h>
#include <kdebug.h>

class Settings : public KConfigSkeleton
{
  public:
    class EnumWindowPlacement
    {
      public:
      enum type { CenterWindow, RememberPosition, NoSpecialHandling, COUNT };
    };
    class EnumSelectedBackend
    {
      public:
      enum type { egrep, agrep, COUNT };
    };

    static Settings *self();
    ~Settings();

    /**
      Set How the window should be placed on the desktop
    */
    static
    void setWindowPlacement( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "WindowPlacement" ) ))
        self()->mWindowPlacement = v;
    }

    /**
      Get How the window should be placed on the desktop
    */
    static
    int windowPlacement()
    {
      return self()->mWindowPlacement;
    }

    /**
      Set Position of the application window
    */
    static
    void setPosition( const QPoint & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "Position" ) ))
        self()->mPosition = v;
    }

    /**
      Get Position of the application window
    */
    static
    QPoint position()
    {
      return self()->mPosition;
    }

    /**
      Set Should a left click on the system tray icon translate the clipboard content?
    */
    static
    void setTranslateOnLeftClick( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "TranslateOnLeftClick" ) ))
        self()->mTranslateOnLeftClick = v;
    }

    /**
      Get Should a left click on the system tray icon translate the clipboard content?
    */
    static
    bool translateOnLeftClick()
    {
      return self()->mTranslateOnLeftClick;
    }

    /**
      Set What backend to use for dictionary lookups?
    */
    static
    void setSelectedBackend( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "SelectedBackend" ) ))
        self()->mSelectedBackend = v;
    }

    /**
      Get What backend to use for dictionary lookups?
    */
    static
    int selectedBackend()
    {
      return self()->mSelectedBackend;
    }

    /**
      Set Should the search be case-sensitive?
    */
    static
    void setCaseSensitive( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "CaseSensitive" ) ))
        self()->mCaseSensitive = v;
    }

    /**
      Get Should the search be case-sensitive?
    */
    static
    bool caseSensitive()
    {
      return self()->mCaseSensitive;
    }

    /**
      Set Should the search match only whole words or also partial strings?
    */
    static
    void setWholeWords( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "WholeWords" ) ))
        self()->mWholeWords = v;
    }

    /**
      Get Should the search match only whole words or also partial strings?
    */
    static
    bool wholeWords()
    {
      return self()->mWholeWords;
    }

    /**
      Set How many errors are permitted when doing an approximate search?
    */
    static
    void setMaximumErrorNumber( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "MaximumErrorNumber" ) ))
        self()->mMaximumErrorNumber = v;
    }

    /**
      Get How many errors are permitted when doing an approximate search?
    */
    static
    int maximumErrorNumber()
    {
      return self()->mMaximumErrorNumber;
    }

    /**
      Set List of recently translated words
    */
    static
    void setRecent( const QStringList & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "Recent" ) ))
        self()->mRecent = v;
    }

    /**
      Get List of recently translated words
    */
    static
    QStringList recent()
    {
      return self()->mRecent;
    }

  protected:
    Settings();
    friend class SettingsHelper;


    // General
    int mWindowPlacement;
    QPoint mPosition;
    bool mTranslateOnLeftClick;

    // Backend
    int mSelectedBackend;
    bool mCaseSensitive;
    bool mWholeWords;
    int mMaximumErrorNumber;

    // History
    QStringList mRecent;

  private:
};

#endif

